/*
 * Copyright (c) 2001 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the University of
 *      California, Los Angeles and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

package FMG.ConductorExt.planners.template;

import java.util.*;

class ItemList {
   String[] items;

   ItemList(Hashtable source, String baseName) {
      Vector values = new Vector();
      for (int i=0; true; i++) {
         String val = (String) source.get(baseName + i);
         if (val == null) {
            break;
         }
         values.addElement(val);
      }

      items = new String[values.size()];
      values.copyInto(items);
   }

   String[] getItems() {
      return items;
   }

   boolean contains(String target) {
      for (int i=0; i<items.length; i++) {
         if (items[i].equals(target)) {
            return true;
         }
      }
      return false;
   }

   boolean containsAll(ItemList other) {
      for (int i=0; i<other.items.length; i++) {
         if (! contains(other.items[i])) {
            return false;
         }
      }
      return true;
   }

   int size() {
      return items.length;
   }

   String item(int i) {
      return items[i];
   }

   int getIndex(String target) {
      for (int i = 0; i< items.length; i++) {
         if (items[i].equals(target)) {
            return i;
         }
      }

      return -1;
   }

   public String toString() {
      StringBuffer sb = new StringBuffer();
      for (int i=0; i<items.length; i++) {
         sb.append(items[i]);
         if (i < items.length-1) {
            sb.append(',');
         }
      }
      return sb.toString();
   }
}
