/*
 * Copyright (c) 2001 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the University of
 *      California, Los Angeles and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <sys/time.h>
#include <unistd.h>

#include "FMG_Conductor_util_Measure.h"

JNIEXPORT jlong JNICALL 
Java_FMG_Conductor_util_Measure_getTime(JNIEnv *env, jclass thisClass) {
   struct timeval tv;

   gettimeofday(&tv, 0);

   jlong time = ((jlong) tv.tv_sec * 1000L) + ((jlong) tv.tv_usec / 1000L);

   return time;
}

JNIEXPORT jobject JNICALL Java_FMG_Conductor_util_Measure_getTimeOfDay
  (JNIEnv *env, jclass thisClass) {
   struct timeval tv;
   gettimeofday(&tv, 0);

  // now create an object to return
  jclass returnClass = env->FindClass("FMG/Conductor/util/Measure$TimeOfDay");

  if (returnClass == 0) {
      return 0;
  }

  jmethodID constructor = env->GetMethodID(returnClass, "<init>", "(II)V");

  if (constructor == 0) {
      return 0;
  }

  jobject ret = env->NewObject(returnClass, constructor, 
                               tv.tv_sec, tv.tv_usec);

  return ret;
}
